/*
 * Main.java
 *
 * Created on March 3, 2006, 1:05 PM
 *
 * 
 */

package sshvncfileaccessablility;
import sshvncfileaccessablility.Global;
import javax.swing.*;
import java.io.*;
import java.awt.*;
/**
 * Runs the SSH of VNC File Accessablity program
 * @author daniel
 */
public class Main {
    
    /** Main */
    public Main() {
    }
    
    /**
     * Creates a new instance of Main which checks if the user is root and if the user is not root the program exits, then it gets all of the programs that are listed int the /usr/share/applicitons file and store them in a list, and finally this will fire the GUI part of this application.
     * @param args the command line arguments
     */
    
    public static void main(String[] args) {
        String s = null;
        try{
            if(!System.getenv("HOME").equalsIgnoreCase("/root")){
                JOptionPane.showMessageDialog(null,
                        "you must be a root user",
                        "improper credentials",
                        JOptionPane.ERROR_MESSAGE);
                System.exit(1);
            }
            
            Process p = Runtime.getRuntime().exec("ls "+Global.ApplicationsFileLocation);
            
            BufferedReader stdInput = new BufferedReader(new 
                 InputStreamReader(p.getInputStream()));

            BufferedReader stdError = new BufferedReader(new 
                 InputStreamReader(p.getErrorStream()));

            // read the output from the command
            
            int count=0;
            while ((s = stdInput.readLine()) != null) {
                Global.list.add(s);
         //       System.out.println(s);
                count++;
            }
            
        }
        catch (Exception e){
            e.printStackTrace();
        }
        /**
         * @step3 fire the Gui
         */
        ProgramList PList = new ProgramList();
        /*for(int i=0;i<PList.size();i++)
        {
            String[] S = PList.get(i).toString().split(";");
            for(int j=0;j<S.length;j++)
                System.out.print(S[j]+"  ");
            System.out.println();
        }*/
        
        
        JFrame frame = new JFrame ("VNC over SSH accessiblity for server");
        frame.setDefaultCloseOperation(frame.EXIT_ON_CLOSE);
        frame.setBounds(0,0,
                Toolkit.getDefaultToolkit().getScreenSize().width-100,
                Toolkit.getDefaultToolkit().getScreenSize().height-100);
        frame.getContentPane().add(new listPanel(PList));
        frame.pack();
        frame.setVisible(true);
    }
    
}
