/*
 * ProgramList.java
 *
 * Created on March 3, 2006, 1:10 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sshvncfileaccessablility;
import java.util.*;
import java.io.*;
import sshvncfileaccessablility.Global;
/**
 * looks through all of the file in the Global.list data Structure and search for the name, comment and executable path for the program.
 * Then it creates a linked list of semicolon seperated strings ex.  NAME;COMMENT;EXECUTABLE for every program in Global.list
 * @author daniel
 */


public class ProgramList extends LinkedList {
    /**puts a comma seperated string of data from the .desktop files into this linked list */
    public void putDataInList(){
        String Data,DataParts[];
        String[] obj = new String[3];
       
        DataInputStream DataIn = new DataInputStream(Global.FileIn);
        try{
            while(DataIn.available()>0){
                Data = DataIn.readLine();
                DataParts = Data.split("=");
                //adds the name of the file
                if(DataParts[0].equals("Name"))
                {
                    obj[0]=DataParts[1];
                    
                }
                //adds the comment for the file
                if(DataParts[0].equals("Comment"))
                {
                    obj[1]=DataParts[1];
                }
                //adds the Executable path for the file;
                if(DataParts[0].equals("Exec"))
                {
                    if(DataParts[1].length()>9&&DataParts[1].substring(0,9).equals(Global.ApplicationsExecutableFolder))
                    {
                        DataParts = DataParts[1].split(" ");
                        obj[2]=DataParts[0];
                    }
                    else
                    {
                        DataParts=(Global.ApplicationsExecutableFolder+DataParts[1]).split(" ");
                        obj[2]=DataParts[0];
                    }
                }
            }
            //creates a comma seperated list and adds it the this linked list;
            String T = obj[0]+";"+obj[1]+";"+obj[2];
            //System.out.println(T);
            this.add(T);
            DataIn.close();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    /**get the data for all the files located in the Global.list structure*/
    public ProgramList(){
        try{
            for(int i=0;i<Global.list.size();i++){
                String S = Global.list.get(i).toString();
                
                if(S.indexOf("desktop") > 0){
                    //creates a file input stream for the current File;
                    Global.FileIn = new FileInputStream(Global.ApplicationsFileLocation+"/"+S);
                    putDataInList();
                    Global.FileIn.close();
                }
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}
